/**
 * @author yutent<yutent.io@gmail.com>
 * @date 2020/09/16 12:07:09
 */

/**
 * [ 判断对象/数组是否为空]
 * eg.
 * Object.empty(obj/arr)
 */
if (!Object.empty) {
  Object.defineProperty(Object, 'empty', {
    value: function (obj) {
      try {
        for (let i in obj) {
          return false
        }
      } catch (e) {}
      return true
    }
  })
}

/**
 * 将对象转为url参数字符串
 * 注意: 这里不会处理复杂类型, 直接按toString结果拼接
 */
if (!Object.prototype.toParams) {
  Object.defineProperty(Object.prototype, 'toParams', {
    value: function () {
      let params = ''
      for (let k in this) {
        if (this[k] === void 0) {
          continue
        }
        params += `&${k}=${this[k]}`
      }
      return params.slice(1)
    }
  })
}
